#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct InvalidDeliveryConfig {
    #[builder(into)]
    #[serde(rename = "fieldName")]
    field_name: String,
    #[builder(default, into)]
    #[serde(rename = "providedValue", skip_serializing_if = "Option::is_none", default)]
    provided_value: Option<i32>,
    #[builder(into)]
    #[serde(rename = "constraint")]
    constraint: String,
}
impl InvalidDeliveryConfig {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(field_name: impl Into<String>, constraint: impl Into<String>) -> Self {
        Self::builder().field_name(field_name).constraint(constraint).build()
    }
    #[inline]
    pub fn field_name(&self) -> &str {
        &*self.field_name
    }
    #[inline]
    pub fn provided_value(&self) -> Option<i32> {
        self.provided_value.as_ref().map(|o| *o)
    }
    #[inline]
    pub fn constraint(&self) -> &str {
        &*self.constraint
    }
}
impl conjure_error::ErrorType for InvalidDeliveryConfig {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "Scout:InvalidDeliveryConfig"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["constraint", "fieldName", "providedValue"]
    }
}
